import {
  XLSX,
} from "../internal";

export class WorkBook {
  protected _category: string;
  protected _created: Date;
  protected _company: string;
  protected _xlsx: XLSX;
  protected _subject: string;
  protected _title: string;
  protected _keywords: string;
  protected _modified: Date;
  protected _description: string;

  public constructor() {
    this._category = '';
    this._created = new Date();
    this._company = '';
    this._subject = '';
    this._title = '';
    this._keywords = '';
    this._modified = this._created;
    this._xlsx = null;
    this._description = '';
  }

  public getKeywords(): string {
    return this._keywords;
  }

  public getXLSX(): XLSX {
    if (!this._xlsx) {
      this._xlsx = new XLSX(this);
    }
    return this._xlsx;
  }

  public getModified(): Date {
    return this._modified;
  }

  public getCategory(): string {
    return this._category;
  }

  public getTitle(): string {
    return this._title;
  }

  public getSubject(): string {
    return this._subject;
  }

  public getCreated(): Date {
    return this._created;
  }

  public getCompany(): string {
    return this._company;
  }
}
